% This script constructs Phi for models with time-varying phi
function Phi = buildPhi_tvp(phi,n,q)
T = size(phi,1);
Phi = speye(n*T);
count = 0;
for i=1:n
    ki = i-1+n*q;
    phi_i = phi(:,count+1:count+ki);
    for j=1:ki
        if j<=i-1
            tmp = sparse(i:n:T*n,j:n:T*n,phi_i(:,j),T*n,T*n);
        else
            pi = ceil((j-i+1)/n);
            tmp = sparse(i+n*pi:n:T*n,mod(j-i+1-1,n)+1:n:(T-pi)*n,phi_i(pi+1:end,j),T*n,T*n);
        end
        Phi = Phi + tmp;
    end
    count = count + i-1+n*q;
end
end
