% compute 1-, 2- and 3-step-ahead forecasts for VARMA(p,q)-SV2
% forecasts are computed assuming p <= 4, q = 1

i = loop-burnin; 
tempbeta = reshape(beta,p*n+1,n)';
mu = tempbeta(:,1);
A = tempbeta(:,2:end);
ftm1 = shortf(end-1,:)';
ftm0 = shortf(end,:)';

Xt = reshape(shortYt(end:-1:end-p+1,:)', n*p,1);      
h1 = h(end,:)' + sqrt(Sigh).*randn(n,1);
phi1 = phi(end,:)' + sqrt(Sigphi).*randn(kp,1);
B(idB) = phi1;
Phi0 = B(:,1:n);
Phi1 = B(:,n+1:2*n); 
ftp1 = exp(h1/2).*randn(n,1);
z1 = mu + A*Xt + Phi1*ftm0;
Sig1 = diag(Lam) + Phi0*diag(exp(h1))*Phi0';
Ytp1 = z1 + Phi0*ftp1 + sqrt(Lam).*randn(n,1);
            
shortYtp1 = [Ytp1'; shortYt(end:-1:end-p+2,:)]';
Xt = reshape(shortYtp1(:,1:p),n*p,1);
h2 = h1 + sqrt(Sigh).*randn(n,1);
phi2 = phi1 + sqrt(Sigphi).*randn(kp,1);
B(idB) = phi2;
Phi0 = B(:,1:n);
Phi1 = B(:,n+1:2*n);
ftp2 = exp(h2/2).*randn(n,1);
z2 = mu + A*Xt + Phi1*ftm1;
Sig2 = diag(Lam) + Phi0*diag(exp(h2))*Phi0';
Ytp2 = z2 + Phi0*ftp2 + sqrt(Lam).*randn(n,1);
            
shortYtp2 = [Ytp2'; Ytp1'; shortYt(end:-1:end-p+3,:)]';
Xt = reshape(shortYtp2(:,1:p),n*p,1);
h3 = h2 + sqrt(Sigh).*randn(n,1);
phi3 = phi2 + sqrt(Sigphi).*randn(kp,1);
B(idB) = phi3;
Phi0 = B(:,1:n);
Phi1 = B(:,n+1:2*n);
ftp3 = exp(h3/2).*randn(n,1);
Sig3 = diag(Lam) + Phi0*diag(exp(h3))*Phi0';
z3 = mu + A*Xt + Phi1*ftp2;            

tempyhat1(i,:) = [log(normpdf(shortY(t+1,:),z1',sqrt(diag(Sig1 ))')) ...
    log(mvnpdf(shortY(t+1,:)',z1,Sig1))];
if t<=T-2
    tempyhat2(i,:) = [log(normpdf(shortY(t+2,:),z2',sqrt(diag(Sig2))')) ...
        log(mvnpdf(shortY(t+2,:)',z2,Sig2))];
end
if t<=T-3
    tempyhat3(i,:) = [log(normpdf(shortY(t+3,:),z3',sqrt(diag(Sig3))')) ...
        log(mvnpdf(shortY(t+3,:)',z3,Sig3))];
end