%% estimate a VAR(p)

% initialize the chain 
bigX = SURform2(X,n);  
newnu = Tt + nu0;   
beta = (bigX'*bigX)\(bigX'*Yt);
err = reshape(Yt - bigX*beta,n,Tt);
Sig = err*err'/Tt;    
invSig = Sig\speye(n);

tempyhat1 = zeros(nloop-burnin,n+1);  
tempyhat2 = zeros(nloop-burnin,n+1); 
tempyhat3 = zeros(nloop-burnin,n+1);

rand('state', sum(100*clock) ); randn('state', sum(200*clock) );
    
for loop = 1:nloop
        %% sample beta
    XinvSig = bigX'*kron(speye(Tt),invSig);
    XinvSigX = XinvSig*bigX;
    invDbeta = invVbeta + XinvSigX;
    betahat = invDbeta\(XinvSig*Yt);    
    flag = 0;
    while flag == 0  % impose stationarity
        beta =  betahat + chol(invDbeta,'lower')'\randn(k,1);
        tempbeta = reshape(beta,p*n+1,n)';
        P(1:n,:) = tempbeta(:,2:end);
        if sum(abs(eig(P))<1) == p*n
            flag = 1;
        end
    end
         
        %% sample Sig
    err = reshape(Yt - bigX*beta,n,Tt);
    newS = S0 + err*err';
    Sig = iwishrnd(newS,newnu);
    invSig = Sig\speye(n);
        
    if loop>burnin %% compute various forecasts
        compute_forecast_VAR
    end    
end    
maxy1 = max(tempyhat1);
maxy2 = max(tempyhat2);
maxy3 = max(tempyhat3);    
