%% estimate the TVP-VARMA(p,1)-SV2

%% compute and define a few things
bigX = SURform([ones(n*Tt,1) kron(X,ones(n,1))]);
Hbeta = speye(Tt*kb) - sparse(kb+1:Tt*kb,1:(Tt-1)*kb,ones((Tt-1)*kb,1),Tt*kb,Tt*kb);

%% initialize the chain
Sigbeta = .1*ones(kb,1);
Sigh = .01*ones(n,1);
Sigphi = .01*ones(kp,1);
var_Y = var(shortYt)';
Lam = var_Y;
h = repmat(log(var_Y)',Tt,1);
f = zeros(Tt*n,1);
phi = zeros(Tt,kp);
Phi = buildPhi_tvp(phi,n,q);

tempyhat1 = zeros(nloop-burnin,n+1); 
tempyhat2 = zeros(nloop-burnin,n+1); 
tempyhat3 = zeros(nloop-burnin,n+1);

rand('state', sum(100*clock) ); randn('state', sum(200*clock) );
    
for loop = 1:nloop
    
        %% sample beta        
    iSbeta = sparse(1:Tt*kb,1:Tt*kb,[1./Vbeta; repmat(1./Sigbeta,Tt-1,1)]);
    Kbeta = Hbeta'*iSbeta*Hbeta + bigX'*sparse(1:Tt*n,1:Tt*n,repmat(1./Lam,Tt,1))*bigX;
    betahat = Kbeta\(bigX'*sparse(1:Tt*n,1:Tt*n,repmat(1./Lam,Tt,1))*(Yt-Phi*f));
    beta =  betahat + chol(Kbeta,'lower')'\randn(Tt*kb,1);
    Xbeta = bigX*beta;      
    
        %% sample f
    PhiinvSigLam = Phi'*sparse(1:Tt*n,1:Tt*n,repmat(1./Lam,Tt,1));
    invDf = sparse(1:Tt*n,1:Tt*n,reshape(exp(-h)',Tt*n,1)) + PhiinvSigLam*Phi;
    fhat = invDf\(PhiinvSigLam*(Yt-Xbeta));
    f = fhat + chol(invDf,'lower')'\randn(Tt*n,1);
    shortf = reshape(f,n,Tt)';
    
        %% sample h  
    for i=1:n
        Ystar = log(shortf(:,i).^2 + .0001 );
        h(:,i) = SVRW(Ystar,h(:,i),Sigh(i),Vh);
    end
    
        %% sample Phi
    Ystar = reshape(Yt-Xbeta,n,Tt)';
    count = 0;
    for i=1:n
        kj = i-1 + n*q;
        Z = zeros(Tt,kj); 
        Z(:,1:i-1) = shortf(:,1:i-1);
        for ii = 1:q
            Z(:,i+(ii-1)*n:i+ii*n-1) = [zeros(ii,n); shortf(1:end-ii,:)];
        end
        bigZ = SURform(Z);
        Hphi = speye(Tt*kj) - sparse(kj+1:Tt*kj,1:(Tt-1)*kj,ones((Tt-1)*kj,1),Tt*kj,Tt*kj);
        Kphi = Hphi'*sparse(1:Tt*kj,1:Tt*kj,[1/Vphi*ones(kj,1); ...
            repmat(1./Sigphi(count+1:kj+count),Tt-1,1)])*Hphi + bigZ'*bigZ/Lam(i);
        phihat = Kphi\(bigZ'*(Ystar(:,i)-shortf(:,i))/Lam(i));        
        tempphi = phihat + chol(Kphi,'lower')'\randn(kj*Tt,1);      
        phi(:,count+1:kj+count) = reshape(tempphi,kj,Tt)';
        count = count + kj;
    end
    Phi = buildPhi_tvp(phi,n,q);
        
        %% sample Lam
    erry = reshape(Yt - Xbeta - Phi*f,n,Tt)';
    newSLam = S0Lam + sum(erry.^2)'/2;
    Lam = 1./gamrnd(nuLam + Tt/2,1./newSLam);
    
        %% sample Sigh
    e2 = (h(2:Tt,:) - h(1:Tt-1,:)).^2;
    Sigh = sample_Sig(Sigh,e2,VSigh);    
   
        %% sample Sigphi
    e2 = (phi(2:Tt,:) - phi(1:Tt-1,:)).^2;
    Sigphi = sample_Sig(Sigphi,e2,VSigphi);    
   
        %% sample Sigbeta
    Beta = reshape(beta,kb,Tt)';
    e2 = (Beta(2:Tt,:) - Beta(1:Tt-1,:)).^2;
    Sigbeta = sample_Sig(Sigbeta,e2,VSigbeta);    
    
    if loop>burnin %% compute various forecasts
       compute_forecast_VARMA_TVP_SV2;
    end    
end 
maxy1 = max(tempyhat1);
maxy2 = max(tempyhat2);
maxy3 = max(tempyhat3);    
